package me.km.blocks;

import java.util.Random;
import me.km.KajetansMod;
import net.minecraft.block.BlockCauldron;
import net.minecraft.block.ITileEntityProvider;
import net.minecraft.block.SoundType;
import net.minecraft.block.state.IBlockState;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

public class BlockModCauldron extends BlockCauldron implements IBlockBase, ITileEntityProvider
{
    protected String name;
    private Item cauldron;

    public BlockModCauldron(String name, String local) 
    {
        this.name = name;
        this.setRegistryName(name);
        super.setUnlocalizedName(local);
        this.cauldron = null;
        super.setHardness(2.0F);
    }
    
    public void setItem(Item cauldron)
    {
        this.cauldron = cauldron;
    }
    
    @Override
    public void registerItemModel(Item itemBlock) 
    {
        KajetansMod.proxy.registerItemRenderer(itemBlock, 0, name);
    }

    @Override
    public BlockModCauldron setSoundType(SoundType sound) 
    {
        super.setSoundType(sound);
        return this;
    }
    
    @Override
    public Item getItemDropped(IBlockState state, Random rand, int fortune)
    {
        return cauldron;
    }

    @Override
    public ItemStack getItem(World worldIn, BlockPos pos, IBlockState state)
    {
        return new ItemStack(cauldron);
    }

    @Override
    public TileEntity createNewTileEntity(World worldIn, int meta) 
    {
        return new TileEntityCauldron();
    }
    
    @Override
    public void breakBlock(World w, BlockPos pos, IBlockState state)
    {
        w.removeTileEntity(pos);
    }
}
