package me.km.blocks;

import net.minecraft.block.state.IBlockState;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.NetworkManager;
import net.minecraft.network.play.server.SPacketUpdateTileEntity;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

public class TileEntityCauldron extends TileEntity
{
    private byte red;
    private byte green;
    private byte blue;
    
    public TileEntityCauldron()
    {
        red = -81;
        green = -61;
        blue = 116;
    }
    
    @Override
    public NBTTagCompound writeToNBT(NBTTagCompound com)
    {
        super.writeToNBT(com);
        com.setByte("red", red);
        com.setByte("green", green);
        com.setByte("blue", blue);
        return com;
    }

    @Override
    protected void setWorldCreate(World w)
    {
        this.setWorld(w);
    }

    @Override
    public void readFromNBT(NBTTagCompound com)
    {
        super.readFromNBT(com);
        red = com.getByte("red");
        green = com.getByte("green");
        blue = com.getByte("blue");
    }

    public int getRed() 
    {
        return red + 128;
    }

    public int getGreen() 
    {
        return green + 128;
    }

    public int getBlue() 
    {
        return blue + 128;
    }

    public void setColor(int red, int green, int blue)
    {
        this.red = (byte) ((red & 0xFF) - 128);
        this.green = (byte) ((green & 0xFF) - 128);
        this.blue = (byte) ((blue & 0xFF) - 128);
        notifyBlockUpdate();
        markDirty();
    }
    
    private void notifyBlockUpdate()
    {
        IBlockState state = world.getBlockState(pos);
        this.world.notifyBlockUpdate(pos, state, state, 3);
    }
    
    @Override
    public SPacketUpdateTileEntity getUpdatePacket()
    {
        return new SPacketUpdateTileEntity(this.pos, -1, this.getUpdateTag());
    }
    
    @Override
    public void onDataPacket(NetworkManager net, SPacketUpdateTileEntity pkt) 
    {
        NBTTagCompound com = pkt.getNbtCompound();
        red = com.getByte("red");
        green = com.getByte("green");
        blue = com.getByte("blue");
        notifyBlockUpdate();
    }

    @Override
    public NBTTagCompound getUpdateTag()
    {
        return this.writeToNBT(new NBTTagCompound());
    }
    
    @Override
    public boolean shouldRefresh(World w, BlockPos pos, IBlockState oldState, IBlockState newState)
    {
        return oldState.getBlock() != newState.getBlock();
    }
}
